#include <SDL.h>
#include "SDL_image.h"

SDL_Window* window;
SDL_Renderer* renderer;

void setupSDL()
  {
  if (SDL_Init(SDL_INIT_TIMER|SDL_INIT_AUDIO|SDL_INIT_VIDEO) != 0)
    {
    printf("SDL failed to init: %s\n", SDL_GetError());
    exit(1);
    }

  // Create window and renderer
  SDL_CreateWindowAndRenderer(600,400, SDL_WINDOW_SHOWN,&window, &renderer);

  if ((window == NULL) || (renderer == NULL))
    {
    printf("SDL_CreateWindowAndRenderer Error: %s\n", SDL_GetError() );
    exit(1);
    }

  }

SDL_Texture* loadImage(const char* filename)
  {
  SDL_Texture *texture;

  texture = IMG_LoadTexture(renderer, filename);
  if (texture == NULL)
    {
    printf("IMG_LoadTexture Error: %s\n", IMG_GetError() );
    exit(1);
    }
                                                             
                                                             
  return texture;                                            
  }                


SDL_Texture* loadKeyedImage(const char* filename)
	{
	SDL_Surface* surface;
	SDL_Texture* texture;

	surface = IMG_Load(filename);
	SDL_SetColorKey(surface, SDL_TRUE, 0xff00ff);
	texture = SDL_CreateTextureFromSurface(renderer, surface);
	return texture;
	}


void postSDLCleanup()                                        
    {                                                        
    SDL_DestroyRenderer(renderer);                           
    SDL_DestroyWindow(window);                               
    SDL_Quit();                                              
    }                                                        
                                                             
       

int main(int argc, char* argv[])
	{
	SDL_Texture* twigman;
	SDL_Texture* kalata;
	SDL_Texture* schemm;
	SDL_Rect ksrc;
	SDL_Rect kdest;
	SDL_Rect tsrc;
	SDL_Rect tdest;
	
	SDL_Event event;

	int kalata_x;
	int kalata_y;
	int kalata_pose;
 	setupSDL();

	twigman = loadImage("TwigManClear.png");
	kalata = loadImage("kalata2.png");
	schemm = loadKeyedImage("Schemm49.png");

	kdest.x = 75; kdest.y  = 50;  kdest.w = 49; kdest.h = 49;
	ksrc.x = 0; ksrc.y = 0; ksrc.w = 49; ksrc.h = 49;
	kalata_x = 5; kalata_y = 0; kalata_pose = 0;
	
	tdest.x = 250; tdest.y = 150; tdest.w = 98; tdest.h = 98;
	tsrc.x = 0; tsrc.y = 0; tsrc.w = 49; tsrc.h = 49;
	
		SDL_SetRenderDrawColor(renderer, 0, 0, 0, 255);

	while(1)
		{
		SDL_RenderClear(renderer);


		SDL_RenderCopy(renderer, kalata, &ksrc, &kdest);
		SDL_RenderCopy(renderer, twigman, &tsrc, &tdest);

		SDL_RenderPresent(renderer);

		kdest.x = kdest.x + kalata_x;
		kdest.y = kdest.y + kalata_y;
		kalata_pose ++;
		ksrc.x = kalata_pose * 49;
		tsrc.x = kalata_pose * 49;
		
		if (kalata_pose == 6) kalata_pose = 0;
		
		
		
		if ((kdest.x == 475) && (kdest.y == 50))
			{
			kalata_x  = 0; kalata_y = 5;
			}
		
		if ((kdest.x == 475) && (kdest.y == 300))
			{
			kalata_x  = -5; kalata_y = 0;
			}
		if ((kdest.x == 75) && (kdest.y == 300))
			{
			kalata_x  = 0; kalata_y = -5;
			}
		if ((kdest.x == 75) && (kdest.y == 50))
			{
			kalata_x  = 5; kalata_y = 0;
			}
			
        if (SDL_PollEvent(&event) > 0)
                       {
                       switch(event.type)
                         {
                         case SDL_QUIT: 
                           exit(0);
                         }
                       }

		SDL_Delay(50);
		}
	

	}
